//#declare compuertas_abiertas=0 --> abre las compuertas
//#declare disparo=3000 --> dispara caon hasta una distancia de 3000

#ifndef (madera)
        #include "marina.tex"
#end

#ifndef (rotacion)
        #declare rotacion=0 //caon mirando hacia popa
#end

#declare casco_b1=
union
{
 sphere
 {
  0,20
  scale <1.5,1,1>
  clipped_by {plane {x,0}}
 }
 sphere
 {
  0,20
  scale <4.5,1,1>
  clipped_by {plane {-x,0}}
  translate x*100
 }
 cylinder {<0,0,0>,<100,0,0>,20}
}

#declare lamina_casco_b=
difference
{
 object{ casco_b1}
 box {<-31,0,21>,<201,-21,-21>}
 box {<-31,21,21>,<201,0,-21> rotate x*29}
 bounded_by {box {<-31,15,21>,<201,-1,-21>}}
}

#declare refuerzos_casco_b=
union
{
 difference //proa
 {
  sphere {0,20.5 scale <1.5,1,1> clipped_by {plane {x,0}}}
  sphere {<0,20,-20>,20.5}
  sphere {<0,20,20>,20.5}
  sphere {<0,-20,20>,20.5}
  sphere {<0,-20,-20>,20.5}
  bounded_by {box {<-31,21,21>,<1,-21,-21>}}
 }
 cylinder {<30,0,0>,<35,0,0>,20.3} //1er refuerzo
 cylinder {<0,0,0>,<5,0,0>,20.3} //2er refuerzo
 cylinder {<65,0,0>,<70,0,0>,20.3} //3o refuerzo
 cylinder {<95,0,0>,<100,0,0>,20.3} //4o refuerzo
 difference //refuerzo y popa
 {
  sphere
  {
   0,20.3
   scale <4.5,1,1>
   clipped_by {plane {-x,0}}
   translate x*100
  }
  box {<125,21,21>,<0,-21,-21>}
  box {<130,21,21>,<150,-21,-21>}
 }
 #declare aa=15 //remaches
 #while (aa<360)
   sphere {0,1.5 scale <1,.75,1> translate <2.5,20.3,0> rotate x*aa}
   sphere {0,1.5 scale <1,.75,1> translate <32.5,20.3,0> rotate x*aa}
   sphere {0,1.5 scale <1,.75,1> translate <67.5,20.3,0> rotate x*aa}
   sphere {0,1.5 scale <1,.75,1> translate <97.5,20.3,0> rotate x*aa}
   sphere {0,1.5 scale <1,.75,1> translate <127.5,19,0> rotate x*aa}
   sphere {0,1.5 scale <1,.75,1> translate <152,16,0> rotate x*aa}
   #declare aa=aa+30
 #end
 sphere {0,1.5 scale <1,.75,1> translate <-15,18,0> }
 sphere {0,1.5 scale <1,.75,1> translate <-15,18,0> rotate x*90}
 sphere {0,1.5 scale <1,.75,1> translate <-15,18,0> rotate x*190}
 sphere {0,1.5 scale <1,.75,1> translate <-15,18,0> rotate x*270}
 texture{metal}
}

#declare espolon_b=
union
{
 cone {<-20,0,0>,12.5,<-45,0,0>,2}
 cone {<-50,0,0>,5,<-45,0,0>,2}
 cone {<-50,0,0>,5,<-85,0,0>,0}
 prism
 {
  linear_spline .15,-.15 12
  <-30,0>,<-20,35>,<-35,10>,<-25,40>,<-50,10>,<-65,5>,<-50,25>,<-83,0>,<-35,-15>,
  <-37,-10>,<-20,-20>,<-30,0> rotate x*-90
 }
 prism
 {
  linear_spline .15,-.15 9
  <-30,0>,<-20,20>,<-35,10>,<-35,15>,<-83,0>,<-35,-15>,<-35,-10>,<-20,-20>,<-30,0>
 }
 prism
 {
  linear_spline .15,-.15 9
  <-30,0>,<-20,20>,<-35,10>,<-35,15>,<-83,0>,<-35,-15>,<-35,-10>,<-20,-20>,<-30,0>
  rotate x*45
 }
 prism
 {
  linear_spline .15,-.15 9
  <-30,0>,<-20,20>,<-35,10>,<-35,15>,<-83,0>,<-35,-15>,<-35,-10>,<-20,-20>,<-30,0>
  rotate x*-45
 }
 texture {metal}
}

#declare aleta1_b=
difference
{
 union
 {
  cylinder { <0,0,.3>,<0,0,-.3>,29 }
  cylinder { <0,.3,0>,<0,-.3,0>,29 }
 }
 box {<0,41,-41>,<41,-41,41>}
 texture {madera}
}

#declare refuerzos_aleta_b=
union
{
 difference
 {
  difference
  {
   cylinder {<0,0,.5>,<0,0,-.5>,30}
   cylinder {<0,0,.6>,<0,0,-.6>,28}
  }
  box {<0,41,-41>,<41,-41,41>}
 }
 sphere {<-29,0,.5>,.5 rotate z*45}
 sphere {<-29,0,.5>,.5 rotate z*-45}
 sphere {<-29,0,.5>,.5 rotate z*88}
 sphere {<-29,0,.5>,.5 rotate z*-88}
 sphere {<-29,0,-.5>,.5 rotate z*45}
 sphere {<-29,0,-.5>,.5 rotate z*-45}
 sphere {<-29,0,-.5>,.5 rotate z*88}
 sphere {<-29,0,-.5>,.5 rotate z*-88}
 texture {metal}
}

#declare timones_b=
union
{
 box {<-4,35,.5>,<0.001,-35,-.5>} //refuerzo
 sphere {<-2.5,22.5,-.5>,.6} //remaches
 sphere {<-2.5,-22.5,-.5>,.6} //remaches
 sphere {<-2.5,22.5,.5>,.6} //remaches
 sphere {<-2.5,-22.5,.5>,.6} //remaches
 box {<-3,30,.65>,<3,34,-.65>} //bisagras
 box {<-3,19,.65>,<3,15,-.65>} //bisagras
 box {<-3,-30,.65>,<3,-34,-.65>} //bisagras
 box {<-3,-19,.65>,<3,-15,-.65>} //bisagras
 cylinder {<0,30,0>,<0,34,0>,1.5} //bisagras
 cylinder {<0,19,0>,<0,15,0>,1.5} //bisagras
 cylinder {<0,-30,0>,<0,-34,0>,1.5} //bisagras
 cylinder {<0,-19,0>,<0,-15,0>,1.5} //bisagras
 box {<1,38,.4>,<10,13,-.4>}
 box {<1,-38,.4>,<10,-13,-.4>}
 texture {metal}
}

#declare mandos_b=
union
{
 box {<1,19.9,7>,<2,20.1,-7>}
 cylinder {<1.5,20,6.5>,<-50,10,5>,.1}
 cylinder {<1.5,20,-6.5>,<-50,10,-5>,.1}
 texture {metal}
}

#declare aleta_b=
union
{
 union
 {
  object {refuerzos_aleta_b}
  object {refuerzos_aleta_b rotate x*90}
  object {aleta1_b}
  scale <1,1.3,1.3>
 }
 object {timones_b}
 object {timones_b rotate x*90}
 object {mandos_b}
 object {mandos_b rotate x*90}
 object {mandos_b rotate x*180}
 object {mandos_b rotate x*270}
 translate x*180
}

#declare pala_b=
union
{
 box {<-3,2,.2>,<3,14,-.2> texture {madera}}
 box {<-2.5,1,.3>,<-4,15,-.3> texture {metal}}
 box {<2.5,1,.3>,<4,15,-.3> texture {metal}}
 box {<4,14,.3>,<-4,15,-.3> texture {metal}}
 box {<4,1,.3>,<-4,2,-.3> texture {metal}}
}

#declare helice_b=
union
{
 #declare aa=0
 #while (aa<360)
  object {pala_b rotate y*45 rotate x*aa translate x*195}
  #declare aa=aa+45
 #end
 difference
 {
  cylinder {<194.5,0,0>,<195.5,0,0>,15.5}
  cylinder {<191,0,0>,<198,0,0>,15}
  texture {metal}
 }
}

#declare torreta1_b=
difference
{
 union
 {
  cylinder {<-10,0,0>,<-10,15,0>,10}
  box {<-10,0,10>,<0,15,-10>}
 }
 union
 {
  box {<-10,-1,-11>,<-10.2,16,11>}
  box {<-21,-1,.1>,<1,16,-.1>}
  cylinder {<-10,8,0>,<-22,8,0>,3.5}
  cylinder {<-10,8,11>,<-10,8,-11>,3.5}
  pigment {rgb 0}
 }
 texture {madera}
}

#declare refuerzos_torreta_b=
union
{
 cylinder {<-10,-5,0>,<-10,2,0>,11}
 box {<-10,-5,11>,<0,2,-11>}
 #declare aa=0
 #while (aa<181)
   sphere {<0,1,-11>,1 rotate y*aa translate x*-10}
   #declare aa=aa+45
 #end
 sphere {<-5,1,11>,1}
 sphere {<-5,1,-11>,1}
 texture {metal}
}

#declare ojo_de_buey_b=
union
{
  difference
  {
    cylinder {<-8,8,0>,<-12,8,0>,4}
    cylinder {<1,8,0>,<-13,8,0>,3}
  }
  torus {4,.1 rotate z*90 translate <-11,8,0> pigment {rgb 0}}
  sphere {<-12,11.5,0>,.5}
  sphere {<-12,4.5,0>,.5}
  sphere {<-12,8,3.5>,.5}
  sphere {<-12,8,-3.5>,.5}
  sphere {0,3 scale <.2,1,1> translate <-10.5,8,0>
          pigment {rgbt <1,1,1,.5>} finish {reflection .6 specular 1 diffuse 0}}
  texture {metal}
}

#declare torreta2_b=
union
{
 cylinder {<0,-5,0>,<0,15,0>,10.1 clipped_by {plane {-x,0}}}
 sphere {<0,13,-10.1>,1 rotate y*-10}
 sphere {<0,13,10.1>,1 rotate y*10}
 sphere {<0,4,-10.1>,1 rotate y*-10}
 sphere {<0,4,10.1>,1 rotate y*10}
 texture {metal}
}

#declare escotilla_torreta_b=
union
{
 cylinder {<5,10,0>,<5,16,0>,5}
 #declare aa=0
 #while (aa<360)
   sphere {<0,0,4.5>,.5 rotate y*aa translate <5,16,0>}
   #declare aa=aa+45
 #end
 sphere {0,4 scale <1,.25,1> translate <5,16,0>}
 cylinder {<5,10,0>,<5,18.5,0>,.2}
 cylinder {<5,18,1.5>,<5,18,-1.5>,.2}
 cylinder {<3.5,18,0>,<6.5,18,0>,.2}
 torus {1.5,.2 translate <5,18,0>}

 box {<7,16,1>,<11,17.5,1.1>}
 box {<7,16,-1>,<11,17.5,-1.1>}
 box {<10,18,.9>,<11,10,.8>}
 box {<10,18,-.9>,<11,10,-.8>}
 cylinder {<10.5,16.5,-1.2>,<10.5,16.5,1.2>,.4}

 texture {metal}
}

#declare puente_b=
union
{
 box {<0,15,3>,<-10,16,-3>} //piso
 cylinder {<-10,15,0>,<-10,16,0>,3} //piso

 torus {10,1 clipped_by {plane {x,0}} translate <-10,15,0>}
 cylinder {<0,15,-10>,<-10,15,-10>,1}
 sphere {<0,15,-10>,1}
 cylinder {<0,15,10>,<-10,15,10>,1}
 sphere {<0,15,10>,1}

 prism {linear_spline -10,-11 6 <0,15>,<0,20>,<-5,25>,<-10,25>,<-10,15>,<0,15> rotate x*-90}
 prism {linear_spline 10,11 6 <0,15>,<0,20>,<-5,25>,<-10,25>,<-10,15>,<0,15> rotate x*-90}
 difference
 {
  cylinder {<-10,15,0>,<-10,25,0>,11}
  cylinder {<-10,14,0>,<-10,26,0>,10}
  box {<-10,13,12>,<3,27,-12>}
 }

 torus {10,1 clipped_by {plane {x,0}} translate <-10,25,0>}
 cylinder {<-5,25,-10>,<-10,25,-10>,1}
 cylinder {<-5,25,10>,<-10,25,10>,1}

 box {<0,15,-9>,<-2,20,-10>}
 box {<0,15,9>,<-2,20,10>}
 box {<-10,15,-9>,<-8,25,-10>}
 box {<-10,15,9>,<-8,25,10>}
 box {<-19.5,15,1>,<-18,25,-1>}

 texture {metal}
}

#declare torreta_b=
union
{
 object {torreta1_b}
 object {refuerzos_torreta_b}
 object {torreta2_b}
 object {puente_b}
 object {escotilla_torreta_b}
 object {ojo_de_buey_b translate x*-10}
 object {ojo_de_buey_b rotate y*90 translate x*-10}
 object {ojo_de_buey_b rotate y*-90 translate x*-10}
}

#declare escotilla_b=
union
{
 cylinder {<0,0,0>,<0,22,0>,8.1}
 cylinder {<0,0,0>,<0,22.1,0>,8}
 #declare aa=0
 #while (aa<360)
  sphere {<0,22.1,7.5>,.5 rotate y*aa}
  #declare aa=aa+30
 #end
 sphere {0,7 scale <1,.25,1> translate y*22.1}
 cylinder {<0,20,0>,<0,24.5,0>,.2}
 cylinder {<-3,24,0>,<3,24,0>,.2}
 cylinder {<0,24,-3>,<0,24,3>,.2}
 torus {3,.2 translate <0,24,0>}

 box {<4,23,2>,<10,22,2.2>}
 box {<4,23,-2>,<10,22,-2.2>}
 box {<8.2,23,1.9>,<10,20,1.7>}
 box {<8.2,23,-1.9>,<10,20,-1.7>}
 cylinder {<9,22,-2.3>,<9,22,2.3>,.5}
 texture {metal}
}

#declare snorkel_b=
union
{
 cylinder {<17,0,0>,<17,83,0>,2}
 sphere {0,4 clipped_by {plane{-y,0}} translate <17,83,0>}
 texture {metal}
}

#declare periscopio_b=
union
{
 cylinder {<10,0,0>,<10,80,0>,2}
 sphere {<10,80,0>,2}
 difference
 {
  cylinder {<5,80,0>,<10,80,0>,2}
  cylinder {<2,80,0>,<10,80,0>,1.5}
 }
 sphere {0,1.5 scale <.2,1,1> translate <6,80,0> pigment {rgb 1} finish {reflection 1}}
 texture {metal}
}

#declare plataforma_b=
union
{
 difference
 {
  superellipsoid {.05 scale <33,11,19> translate <65,11,0>}
  box{<35,20,17>,<95,25,-17>}
 }
 sphere {<40,8,19>,1} sphere {<55,8,19>,1} sphere {<75,8,19>,1} sphere {<90,8,19>,1}
 sphere {<40,8,-19>,1} sphere {<55,8,-19>,1} sphere {<75,8,-19>,1} sphere {<90,8,-19>,1}
 box {<35,20,17>,<95,20.1,-17> pigment {rgb 0}}
 texture {metal}
}

#declare compuerta_izquierda_b=
union
{
  box {<35.1,-2,16>,<94.9,0,6.9> texture {madera translate x*-50}}
  box {<35.1,-2,7>,<94.9,0,1> texture {madera translate x*-150}}
  cylinder {<40,0,0>,<45,0,0>,1}
  cylinder {<80,0,0>,<85,0,0>,1}
  cylinder {<45.1,0,0>,<50,0,0>,1}
  cylinder {<85.1,0,0>,<90,0,0>,1}
  box {<35.09,.05,5>,<94.91,-2.05,.05>}
  sphere {<40,.05,2.5>,1}  sphere {<90,.05,2.5>,1}
  sphere {<40,-2.05,2.5>,1}  sphere {<90,-2.05,2.5>,1}
  box {<35.09,.05,12>,<94.91,-2.05,16.9>}
  sphere {<45,.05,14.5>,1}  sphere {<85,.05,14.5>,1}
  sphere {<45,-2.05,14.5>,1}  sphere {<85,-2.05,14.5>,1}
  torus {1,.2 rotate z*90 translate <37,.05,14> }
  torus {1,.2 rotate z*90 translate <92,.05,14> }
  box {<67,-2,13>,<73,-5,15.5>} //cerradura
  box {<68,-2.01,5>,<72,-4,16>} //cerradura
  texture {metal}
  #ifdef (compuertas_abiertas)
    rotate x*180
  #end
  translate <0,22,-17>
}

#declare compuerta_derecha_b=
union
{
  box {<35.1,-2,-16>,<94.9,0,-6.9> texture {madera translate x*50}}
  box {<35.1,-2,-7>,<94.9,0,-1> texture {madera translate x*150}}
  cylinder {<40,0,0>,<45,0,0>,1}
  cylinder {<80,0,0>,<85,0,0>,1}
  cylinder {<45.1,0,0>,<50,0,0>,1}
  cylinder {<85.1,0,0>,<90,0,0>,1}
  box {<35.09,.05,-5>,<94.91,-2.05,-.05>}
  sphere {<40,.05,-2.5>,1}  sphere {<90,.05,-2.5>,1}
  sphere {<40,-2.05,-2.5>,1}  sphere {<90,-2.05,-2.5>,1}
  box {<35.09,.05,-12>,<94.91,-2.05,-16.9>}
  sphere {<45,.05,-14.5>,1}  sphere {<85,.05,-14.5>,1}
  sphere {<45,-2.05,-14.5>,1}  sphere {<85,-2.05,-14.5>,1}
  torus {1,.2 rotate z*90 translate <37,.05,-14> }
  torus {1,.2 rotate z*90 translate <92,.05,-14> }
  difference
  {
   box {<67,-2,-13>,<73,-5,-15.5>} //cerradura
   box {<68,-2.01,-5>,<72,-4,-16>} //cerradura
  }
  texture {metal}
  #ifdef (compuertas_abiertas)
    rotate x*-180
  #end
  translate <0,22,17>
}

#declare plataforma_canon=
union
{
 box {<35.1,21,16.9>,<94.9,20,6> texture {madera translate x*-70}}
 box {<35.1,21,5.9>,<94.9,20,.05> texture {madera translate x*-170}}
 box {<35.1,21,-.05>,<94.9,20,-5.9> texture {madera translate x*170}}
 box {<35.1,21,-16.9>,<94.9,20,-6> texture {madera translate x*70}}
 box {<37,21.1,15>,<45,20,13>} box {<37,21.1,8>,<45,20,10>} box {<37,21.1,5>,<45,20,3>}
 box {<37,21.1,-15>,<45,20,-13>} box {<37,21.1,-8>,<45,20,-10>} box {<37,21.1,-5>,<45,20,-3>}
 box {<75,21.1,15>,<90,20,13>} box {<75,21.1,8>,<90,20,10>} box {<75,21.1,5>,<90,20,3>}
 box {<75,21.1,-15>,<90,20,-13>} box {<75,21.1,-8>,<90,20,-10>} box {<75,21.1,-5>,<90,20,-3>}
 texture {metal}
}

#declare canon=
union
{
 difference //plataforma 1
 {
  cone {<0,0,0>,14,<0,4.9,0>,13}
  union
  {
   #declare aa=0
   #while (aa<360)
     box {<-20,-1,.05>,<20,6,-.05> rotate y*aa pigment {rgb 0}}
     #declare aa=aa+30
   #end
  }
  bounded_by {box {<-21,-2,-21>,<21,7,21>}}
  texture {metal}
 }
 difference //plataforma 2
 {
  cylinder {<0,4.9,0>,<0,5,0>,11}
  box {<-5,4,15>,<-5.1,6,-15>}  box {<5,4,15>,<5.1,6,-15>}
  bounded_by {box {<-21,-2,-21>,<21,7,21>}}
  texture {madera}
 }
 union //soporte A
 {
  difference
  {
   union
   {
    box {<-15,5,-15>,<5,10,-16>}
    box {<-15,5,15>,<5,10,16>}
   }
   cylinder {<-7.5,7.5,-17>,<-7.5,7.5,17>,1.5}
   cylinder {<-2.5,7.5,-17>,<-2.5,7.5,17>,1.5}
   cylinder {<2.5,7.5,-17>,<2.5,7.5,17>,1.5}
  }
  difference
  {
   union
   {
    cylinder {<5,20,-15>,<5,20,-16>,15}
    cylinder {<5,20,15>,<5,20,16>,15}
   }
   cylinder {<5,20,-17>,<5,20,17>,10}
   box {<5,37,-17>,<-15,0,17>}
   box {<-15,22,-17>,<21,40,17>}
  }
  cylinder {<17.5,20,-17>,<17.5,20,-15>,1}
  cylinder {<17.5,20,17>,<17.5,20,15>,1}
  difference
  {
   union
   {
    box {<-5,5,-15>,<-6,10,15>}
    box {<5,5,-15>,<6,10,15>}
    box {<-10.5,5,-15>,<-11.5,10,15>}
   }
   cylinder {<-12,7.5,-12.5>,<10,7.5,-12.5>,1.5}
   cylinder {<-12,7.5,12.5>,<10,7.5,12.5>,1.5}
   cylinder {<-12,7.5,-5>,<10,7.5,-5>,1.5}
   cylinder {<-12,7.5,5>,<10,7.5,5>,1.5}
  }
 }

 difference //soporte bola
 {
  union
  {
   cylinder {<-1,20,0>,<1,20,0>,10.05}
   cylinder {<-.5,5,0>,<.5,5,0>,10 clipped_by {box {<-1,5,11>,<1,40,-11>}}}
  }
  cylinder {<-1.1,20,0>,<1.1,20,0>,10}
 }

 difference //soporte lente mayor
 {
   union
   {
    cylinder {<16,20,0>,<18,20,0>,15}
    box {<16,21,16>,<18,19,-16>}
    box {<16,36,1>,<18,4,-1>}
   }
   cylinder {<15,20,0>,<19,20,0>,14.5}
   bounded_by { cylinder {<14,20,0>,<20,20,0>,17} }
 }

 difference //soporte lente menor
 {
   union
   {
    cylinder {<33,20,0>,<35,20,0>,10}
    box {<33,21,11>,<35,19,-11>}
    box {<33,31,1>,<35,9,-1>}
   }
   cylinder {<32,20,0>,<36,20,0>,9.5}
   bounded_by { cylinder {<31,20,0>,<37,20,0>,11} }
 }

 union //union soportes de lentes
 {
  cylinder {<18,35.5,0>,<33,30.5,0>,.5}
  cylinder {<18,4.5,0>,<33,9.5,0>,.5}
  cylinder {<18,20,-15.5>,<33,20,-10.5>,.5}
  cylinder {<18,20,15.5>,<33,20,10.5>,.5}
 }

 union //cuadro soporte lente trasera
 {
  box {<-10,5,-8>,<-12,35,-7>}
  box {<-10,34,-8>,<-12,35,8>}
  box {<-10,5,8>,<-12,35,7>}
  box {<-10,32,-5>,<-12,34,-7>}
  box {<-10,32,5>,<-12,34,7>}
  cylinder {<-10,33,-6>,<15,20,-15.5>,.5}
  cylinder {<-10,33,6>,<15,20,15.5>,.5}
 }

 difference //arco soporte lente trasera
 {
  difference
  {
   union
   {
    cylinder {<-11,20,-7>,<-11,20,-8>,15}
    cylinder {<-11,20,7>,<-11,20,8>,15}
   }
   cylinder {<-11,20,9>,<-11,20,-9>,13}
   box {<-11,36,-9>,<7,-4,9>}
  }
  #declare aa=15
  #while (aa<180)
    cylinder {<0,14,-9>,<0,14,9>,.75 rotate z*aa translate <-11,20,0>}
    #declare aa=aa+15
  #end
 }

 union
 {
  difference //soporte y lente trasera
  {
   union
   {
    cylinder {<-13,0,0>,<-15,0,0>,6.5}
    box {<-13,2,9>,<-15,-2,-9>}
   }
   cylinder {<-12,0,0>,<-16,0,0>,6}
   bounded_by { cylinder {<-17,0,0>,<-11,0,0>,7} }
  }
  sphere //lente trasera
  {
   0,6
   scale <.2,1,1>
   pigment {rgb .9 transmit 1}
   finish {specular 1 roughness .0005 reflection .5 refraction 1 ior 1.5}
   translate <-14,0,0>
  }
  rotate z*-45 translate <-11,20,0>
 }

 sphere //lente mayor
 {
  0,14.5
  scale <.2,1,1>
  pigment {rgb .9 transmit 1}
  finish {specular 1 roughness .0005 reflection .5 refraction 1 ior 1.5}
  translate <17,20,0>
 }

 sphere //lente menor
 {
  0,9.5
  scale <.2,1,1>
  pigment {rgb .9 transmit 1}
  finish {specular 1 roughness .0005 reflection .5 refraction 1 ior 1.5}
  translate <34,20,0>
 }

 sphere //esfera
 {
  0,1
  hollow
  no_shadow
  pigment
  {
   marble
   turbulence 3
   color_map
   {
    [0 rgb 3]
    [.1 rgbt .9]
    [.5 rgbt .9]
    [.51 rgb <3,3,0>]
    [.52 rgbt .9]
    [1 rgbt .9]
   }
  }
  finish {ambient 1}
  halo
  {
   linear
   emitting
   turbulence .01
   jitter 2
   color_map
   {
    [0 rgbt <0,1,0,1>]
    [.1 blue 1]
    [1 rgb <2,2,2>]
   }
  }
  scale 10
  translate <0,20,0>
 }

 light_source {<0,20,0> rgb <.25,.25,3> fade_distance 50 fade_power 2}
 #ifdef (disparo)
  sphere
  {
   0,1
   hollow
   no_shadow
   pigment {rgbt 1}
   halo
   {
    linear
    emitting
    turbulence .5
    lambda 5
    jitter 10
    color_map
    {
      [0 rgbt <0,1,0,1>]
      [.1 blue 1 transmit .5]
      [1 rgbt <2,2,2,.5>]
    }
    rotate z*90
   }
   scale 5 scale <2,1,1> translate <25,20,0>
  }
  cylinder
  {
   0,x*1,1
   hollow
   no_shadow
   pigment {rgbt 1}
   halo
   {
    linear
    emitting
    cylindrical_mapping
    color_map
    {
      [0 rgbt <0,1,0,1>]
      [.1 blue 1]
      [1 rgb <2,2,2>]
    }
    rotate z*90
   }
   scale <disparo,2.5,2.5> translate <36,20,0>
  }
 #end
 texture {laton}
}

#declare ssb_mk2=
union
{
 #declare aa=0
 #while (aa<360)
  object {lamina_casco_b rotate x*aa texture {madera translate (aa*35)*26}}
  #declare aa=aa+30
 #end
 object {refuerzos_casco_b}
 object {espolon_b}
 object {aleta_b}
 union //eje helice
 {
  cylinder {<180,0,0>,<200,0,0>,1}
  sphere {<200,0,0>,1}
  texture {metal}
 }
 object {helice_b}
 object {torreta_b translate <20,20,0>}
 object {escotilla_b translate x*110}
 object {snorkel_b}
 object {periscopio_b}
 object {plataforma_b}
 object {compuerta_derecha_b}
 object {compuerta_izquierda_b}
 object {plataforma_canon}
 #ifdef (compuertas_abiertas)
  object {canon scale .9 rotate y*rotacion translate <60,21,0>}
 #end
 #ifdef (estela)
 union
 {
  sphere  {   0,1 hollow no_shadow pigment {rgbt 1}
   halo   {  linear glowing turbulence .1  lambda 5  jitter 10
    color_map  {    [0 rgbt 1] [.5 rgbt .5]   [1 rgb 2]  } }
   clipped_by {plane {-x,0}} scale <7.5,1,1> }
  sphere  {   0,1 hollow no_shadow pigment {rgbt 1}
   halo   {  linear glowing turbulence .1  lambda 5  jitter 10
    color_map  {    [0 rgbt 1] [.5 rgbt .5] [1 rgb 2]  } }
   clipped_by {plane {x,0}}  }
   scale 30  translate x*195
  }
 #end
}
